package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TCantonfairRedemption;
import com.haomostudio.so.service.TCantonfairRedemptionService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TCantonfairRedemption")
@Controller
public class TCantonfairRedemptionController {

    @Autowired
    TCantonfairRedemptionService tCantonfairRedemptionService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TCantonfairRedemption'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_cantonfair_redemptions/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTCantonfairRedemption(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "orderNum", required = false) String orderNum,
            @RequestParam(value = "startDate", required = false) String startDate,
            @RequestParam(value = "expireDate", required = false) String expireDate,
            @RequestParam(value = "customerId", required = false) Integer customerId,
            @RequestParam(value = "cantonfairCheckerId", required = false) Integer cantonfairCheckerId,
            @RequestParam(value = "cantonfairCouponId", required = false) Integer cantonfairCouponId,
            @RequestParam(value = "redemptionStatus", required = false) Integer redemptionStatus,
            @RequestParam(value = "redemptionShopId", required = false) Integer redemptionShopId,
            @RequestParam(value = "redemptionDate", required = false) String redemptionDate,
            @RequestParam(value = "createDate", required = false) String createDate,
            @RequestParam(value = "modifiedDate", required = false) String modifiedDate
    ) {
        TCantonfairRedemption item = new TCantonfairRedemption();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( orderNum != null ){
            item.setOrderNum(orderNum);
        }
        if( startDate != null ){
            item.setStartDate(Tools.convertStringToDate(startDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( expireDate != null ){
            item.setExpireDate(Tools.convertStringToDate(expireDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( customerId != null ){
            item.setCustomerId(customerId);
        }
        if( cantonfairCheckerId != null ){
            item.setCantonfairCheckerId(cantonfairCheckerId);
        }
        if( cantonfairCouponId != null ){
            item.setCantonfairCouponId(cantonfairCouponId);
        }
        if( redemptionStatus != null ){
            item.setRedemptionStatus(redemptionStatus);
        }
        if( redemptionShopId != null ){
            item.setRedemptionShopId(redemptionShopId);
        }
        if( redemptionDate != null ){
            item.setRedemptionDate(Tools.convertStringToDate(redemptionDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( createDate != null ){
            item.setCreateDate(Tools.convertStringToDate(createDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( modifiedDate != null ){
            item.setModifiedDate(Tools.convertStringToDate(modifiedDate, "yyyy-MM-dd HH:mm:ss"));
        }
        tCantonfairRedemptionService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tCantonfairRedemptionService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TCantonfairRedemption'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_cantonfair_redemptions/{t_cantonfair_redemption_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTCantonfairRedemption(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_cantonfair_redemption_id") Integer id
    ) {
        TCantonfairRedemption item = tCantonfairRedemptionService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tCantonfairRedemptionService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TCantonfairRedemption'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_cantonfair_redemptions/{t_cantonfair_redemption_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTCantonfairRedemption(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_cantonfair_redemption_id") Integer id,
            @RequestParam(value = "orderNum", required = false) String orderNum,
            @RequestParam(value = "startDate", required = false) String startDate,
            @RequestParam(value = "expireDate", required = false) String expireDate,
            @RequestParam(value = "customerId", required = false) Integer customerId,
            @RequestParam(value = "cantonfairCheckerId", required = false) Integer cantonfairCheckerId,
            @RequestParam(value = "cantonfairCouponId", required = false) Integer cantonfairCouponId,
            @RequestParam(value = "redemptionStatus", required = false) Integer redemptionStatus,
            @RequestParam(value = "redemptionShopId", required = false) Integer redemptionShopId,
            @RequestParam(value = "redemptionDate", required = false) String redemptionDate,
            @RequestParam(value = "createDate", required = false) String createDate,
            @RequestParam(value = "modifiedDate", required = false) String modifiedDate
    ) {
        TCantonfairRedemption item = tCantonfairRedemptionService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( orderNum != null ){
            item.setOrderNum(orderNum);
        }
        if( startDate != null ){
            item.setStartDate(Tools.convertStringToDate(startDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( expireDate != null ){
            item.setExpireDate(Tools.convertStringToDate(expireDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( customerId != null ){
            item.setCustomerId(customerId);
        }
        if( cantonfairCheckerId != null ){
            item.setCantonfairCheckerId(cantonfairCheckerId);
        }
        if( cantonfairCouponId != null ){
            item.setCantonfairCouponId(cantonfairCouponId);
        }
        if( redemptionStatus != null ){
            item.setRedemptionStatus(redemptionStatus);
        }
        if( redemptionShopId != null ){
            item.setRedemptionShopId(redemptionShopId);
        }
        if( redemptionDate != null ){
            item.setRedemptionDate(Tools.convertStringToDate(redemptionDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( createDate != null ){
            item.setCreateDate(Tools.convertStringToDate(createDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( modifiedDate != null ){
            item.setModifiedDate(Tools.convertStringToDate(modifiedDate, "yyyy-MM-dd HH:mm:ss"));
        }
        tCantonfairRedemptionService.update(item);

        return tCantonfairRedemptionService.get(id);
    }

    @ApiOperation(value = "查询'TCantonfairRedemption'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_cantonfair_redemptions/{t_cantonfair_redemption_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTCantonfairRedemption(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_cantonfair_redemption_id") Integer id,
            @RequestParam(value = "orderNum", required = false) String orderNum,
            @RequestParam(value = "startDate", required = false) String startDate,
            @RequestParam(value = "expireDate", required = false) String expireDate,
            @RequestParam(value = "customerId", required = false) Integer customerId,
            @RequestParam(value = "cantonfairCheckerId", required = false) Integer cantonfairCheckerId,
            @RequestParam(value = "cantonfairCouponId", required = false) Integer cantonfairCouponId,
            @RequestParam(value = "redemptionStatus", required = false) Integer redemptionStatus,
            @RequestParam(value = "redemptionShopId", required = false) Integer redemptionShopId,
            @RequestParam(value = "redemptionDate", required = false) String redemptionDate,
            @RequestParam(value = "createDate", required = false) String createDate,
            @RequestParam(value = "modifiedDate", required = false) String modifiedDate
    ) {
        if(request.getMethod().equals("GET")){
            TCantonfairRedemption item = tCantonfairRedemptionService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TCantonfairRedemption item = tCantonfairRedemptionService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( orderNum != null ){
                item.setOrderNum(orderNum);
            }
            if( startDate != null ){
                item.setStartDate(Tools.convertStringToDate(startDate, "yyyy-MM-dd HH:mm:ss"));
            }
            if( expireDate != null ){
                item.setExpireDate(Tools.convertStringToDate(expireDate, "yyyy-MM-dd HH:mm:ss"));
            }
            if( customerId != null ){
                item.setCustomerId(customerId);
            }
            if( cantonfairCheckerId != null ){
                item.setCantonfairCheckerId(cantonfairCheckerId);
            }
            if( cantonfairCouponId != null ){
                item.setCantonfairCouponId(cantonfairCouponId);
            }
            if( redemptionStatus != null ){
                item.setRedemptionStatus(redemptionStatus);
            }
            if( redemptionShopId != null ){
                item.setRedemptionShopId(redemptionShopId);
            }
            if( redemptionDate != null ){
                item.setRedemptionDate(Tools.convertStringToDate(redemptionDate, "yyyy-MM-dd HH:mm:ss"));
            }
            if( createDate != null ){
                item.setCreateDate(Tools.convertStringToDate(createDate, "yyyy-MM-dd HH:mm:ss"));
            }
            if( modifiedDate != null ){
                item.setModifiedDate(Tools.convertStringToDate(modifiedDate, "yyyy-MM-dd HH:mm:ss"));
            }
            tCantonfairRedemptionService.update(item);

            return tCantonfairRedemptionService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TCantonfairRedemption item = tCantonfairRedemptionService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tCantonfairRedemptionService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TCantonfairRedemption'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_cantonfair_redemptions",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTCantonfairRedemptions(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tCantonfairRedemptionService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tCantonfairRedemptionService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_cantonfair_redemptions/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTCantonfairRedemptionsId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TCantonfairRedemption> list = tCantonfairRedemptionService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TCantonfairRedemption.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TCantonfairRedemption'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_cantonfair_redemptions/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTCantonfairRedemptions(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TCantonfairRedemption> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TCantonfairRedemption item = new TCantonfairRedemption();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("orderNum")   ){
            item.setOrderNum(jsonObject.get("orderNum").toString());
        }
        if(jsonObject.containsKey("startDate")   ){
            item.setStartDate(Tools.convertStringToDate(jsonObject.get("startDate").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("expireDate")   ){
            item.setExpireDate(Tools.convertStringToDate(jsonObject.get("expireDate").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("customerId")   ){
            item.setCustomerId(Integer.valueOf(jsonObject.get("customerId").toString()));
        }
        if(jsonObject.containsKey("cantonfairCheckerId")   ){
            item.setCantonfairCheckerId(Integer.valueOf(jsonObject.get("cantonfairCheckerId").toString()));
        }
        if(jsonObject.containsKey("cantonfairCouponId")   ){
            item.setCantonfairCouponId(Integer.valueOf(jsonObject.get("cantonfairCouponId").toString()));
        }
        if(jsonObject.containsKey("redemptionStatus")   ){
            item.setRedemptionStatus(Integer.valueOf(jsonObject.get("redemptionStatus").toString()));
        }
        if(jsonObject.containsKey("redemptionShopId")   ){
            item.setRedemptionShopId(Integer.valueOf(jsonObject.get("redemptionShopId").toString()));
        }
        if(jsonObject.containsKey("redemptionDate")   ){
            item.setRedemptionDate(Tools.convertStringToDate(jsonObject.get("redemptionDate").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("createDate")   ){
            item.setCreateDate(Tools.convertStringToDate(jsonObject.get("createDate").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("modifiedDate")   ){
            item.setModifiedDate(Tools.convertStringToDate(jsonObject.get("modifiedDate").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
             tCantonfairRedemptionService.create(item);
             lists.add(tCantonfairRedemptionService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TCantonfairRedemption'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_cantonfair_redemptions/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTCantonfairRedemption(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TCantonfairRedemption item = tCantonfairRedemptionService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tCantonfairRedemptionService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
