package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TEnter;
import com.haomostudio.so.service.TEnterService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TEnter")
@Controller
public class TEnterController {

    @Autowired
    TEnterService tEnterService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TEnter'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_enters/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTEnter(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "storeId", required = false) Integer storeId,
            @RequestParam(value = "name", required = false) String name,
            @RequestParam(value = "mobile", required = false) String mobile,
            @RequestParam(value = "email", required = false) String email,
            @RequestParam(value = "outh2UserId", required = false) Integer outh2UserId,
            @RequestParam(value = "companyName", required = false) String companyName,
            @RequestParam(value = "companyCode", required = false) String companyCode,
            @RequestParam(value = "introduction", required = false) String introduction,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "comment", required = false) String comment,
            @RequestParam(value = "companyScaleCode", required = false) String companyScaleCode,
            @RequestParam(value = "companyScaleName", required = false) String companyScaleName,
            @RequestParam(value = "professionCode", required = false) String professionCode,
            @RequestParam(value = "professionName", required = false) String professionName,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated,
            @RequestParam(value = "solvedTime", required = false) String solvedTime
    ) {
        TEnter item = new TEnter();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( storeId != null ){
            item.setStoreId(storeId);
        }
        if( name != null ){
            item.setName(name);
        }
        if( mobile != null ){
            item.setMobile(mobile);
        }
        if( email != null ){
            item.setEmail(email);
        }
        if( outh2UserId != null ){
            item.setOuth2UserId(outh2UserId);
        }
        if( companyName != null ){
            item.setCompanyName(companyName);
        }
        if( companyCode != null ){
            item.setCompanyCode(companyCode);
        }
        if( introduction != null ){
            item.setIntroduction(introduction);
        }
        if( status != null ){
            item.setStatus(status);
        }
        if( comment != null ){
            item.setComment(comment);
        }
        if( companyScaleCode != null ){
            item.setCompanyScaleCode(companyScaleCode);
        }
        if( companyScaleName != null ){
            item.setCompanyScaleName(companyScaleName);
        }
        if( professionCode != null ){
            item.setProfessionCode(professionCode);
        }
        if( professionName != null ){
            item.setProfessionName(professionName);
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        if( updated != null ){
            item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
        }
        if( solvedTime != null ){
            item.setSolvedTime(Tools.convertStringToDate(solvedTime, "yyyy-MM-dd HH:mm:ss"));
        }
        tEnterService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tEnterService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TEnter'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_enters/{t_enter_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTEnter(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_enter_id") Integer id
    ) {
        TEnter item = tEnterService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tEnterService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TEnter'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_enters/{t_enter_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTEnter(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_enter_id") Integer id,
            @RequestParam(value = "storeId", required = false) Integer storeId,
            @RequestParam(value = "name", required = false) String name,
            @RequestParam(value = "mobile", required = false) String mobile,
            @RequestParam(value = "email", required = false) String email,
            @RequestParam(value = "outh2UserId", required = false) Integer outh2UserId,
            @RequestParam(value = "companyName", required = false) String companyName,
            @RequestParam(value = "companyCode", required = false) String companyCode,
            @RequestParam(value = "introduction", required = false) String introduction,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "comment", required = false) String comment,
            @RequestParam(value = "companyScaleCode", required = false) String companyScaleCode,
            @RequestParam(value = "companyScaleName", required = false) String companyScaleName,
            @RequestParam(value = "professionCode", required = false) String professionCode,
            @RequestParam(value = "professionName", required = false) String professionName,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated,
            @RequestParam(value = "solvedTime", required = false) String solvedTime
    ) {
        TEnter item = tEnterService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( storeId != null ){
            item.setStoreId(storeId);
        }
        if( name != null ){
            item.setName(name);
        }
        if( mobile != null ){
            item.setMobile(mobile);
        }
        if( email != null ){
            item.setEmail(email);
        }
        if( outh2UserId != null ){
            item.setOuth2UserId(outh2UserId);
        }
        if( companyName != null ){
            item.setCompanyName(companyName);
        }
        if( companyCode != null ){
            item.setCompanyCode(companyCode);
        }
        if( introduction != null ){
            item.setIntroduction(introduction);
        }
        if( status != null ){
            item.setStatus(status);
        }
        if( comment != null ){
            item.setComment(comment);
        }
        if( companyScaleCode != null ){
            item.setCompanyScaleCode(companyScaleCode);
        }
        if( companyScaleName != null ){
            item.setCompanyScaleName(companyScaleName);
        }
        if( professionCode != null ){
            item.setProfessionCode(professionCode);
        }
        if( professionName != null ){
            item.setProfessionName(professionName);
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        if( updated != null ){
            item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
        }
        if( solvedTime != null ){
            item.setSolvedTime(Tools.convertStringToDate(solvedTime, "yyyy-MM-dd HH:mm:ss"));
        }
        tEnterService.update(item);

        return tEnterService.get(id);
    }

    @ApiOperation(value = "查询'TEnter'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_enters/{t_enter_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTEnter(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_enter_id") Integer id,
            @RequestParam(value = "storeId", required = false) Integer storeId,
            @RequestParam(value = "name", required = false) String name,
            @RequestParam(value = "mobile", required = false) String mobile,
            @RequestParam(value = "email", required = false) String email,
            @RequestParam(value = "outh2UserId", required = false) Integer outh2UserId,
            @RequestParam(value = "companyName", required = false) String companyName,
            @RequestParam(value = "companyCode", required = false) String companyCode,
            @RequestParam(value = "introduction", required = false) String introduction,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "comment", required = false) String comment,
            @RequestParam(value = "companyScaleCode", required = false) String companyScaleCode,
            @RequestParam(value = "companyScaleName", required = false) String companyScaleName,
            @RequestParam(value = "professionCode", required = false) String professionCode,
            @RequestParam(value = "professionName", required = false) String professionName,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated,
            @RequestParam(value = "solvedTime", required = false) String solvedTime
    ) {
        if(request.getMethod().equals("GET")){
            TEnter item = tEnterService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TEnter item = tEnterService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( storeId != null ){
                item.setStoreId(storeId);
            }
            if( name != null ){
                item.setName(name);
            }
            if( mobile != null ){
                item.setMobile(mobile);
            }
            if( email != null ){
                item.setEmail(email);
            }
            if( outh2UserId != null ){
                item.setOuth2UserId(outh2UserId);
            }
            if( companyName != null ){
                item.setCompanyName(companyName);
            }
            if( companyCode != null ){
                item.setCompanyCode(companyCode);
            }
            if( introduction != null ){
                item.setIntroduction(introduction);
            }
            if( status != null ){
                item.setStatus(status);
            }
            if( comment != null ){
                item.setComment(comment);
            }
            if( companyScaleCode != null ){
                item.setCompanyScaleCode(companyScaleCode);
            }
            if( companyScaleName != null ){
                item.setCompanyScaleName(companyScaleName);
            }
            if( professionCode != null ){
                item.setProfessionCode(professionCode);
            }
            if( professionName != null ){
                item.setProfessionName(professionName);
            }
            if( created != null ){
                item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
            }
            if( updated != null ){
                item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
            }
            if( solvedTime != null ){
                item.setSolvedTime(Tools.convertStringToDate(solvedTime, "yyyy-MM-dd HH:mm:ss"));
            }
            tEnterService.update(item);

            return tEnterService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TEnter item = tEnterService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tEnterService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TEnter'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_enters",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTEnters(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tEnterService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tEnterService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_enters/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTEntersId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TEnter> list = tEnterService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TEnter.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TEnter'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_enters/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTEnters(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TEnter> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TEnter item = new TEnter();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("storeId")   ){
            item.setStoreId(Integer.valueOf(jsonObject.get("storeId").toString()));
        }
        if(jsonObject.containsKey("name")   ){
            item.setName(jsonObject.get("name").toString());
        }
        if(jsonObject.containsKey("mobile")   ){
            item.setMobile(jsonObject.get("mobile").toString());
        }
        if(jsonObject.containsKey("email")   ){
            item.setEmail(jsonObject.get("email").toString());
        }
        if(jsonObject.containsKey("outh2UserId")   ){
            item.setOuth2UserId(Integer.valueOf(jsonObject.get("outh2UserId").toString()));
        }
        if(jsonObject.containsKey("companyName")   ){
            item.setCompanyName(jsonObject.get("companyName").toString());
        }
        if(jsonObject.containsKey("companyCode")   ){
            item.setCompanyCode(jsonObject.get("companyCode").toString());
        }
        if(jsonObject.containsKey("introduction")   ){
            item.setIntroduction(jsonObject.get("introduction").toString());
        }
        if(jsonObject.containsKey("status")   ){
            item.setStatus(Integer.valueOf(jsonObject.get("status").toString()));
        }
        if(jsonObject.containsKey("comment")   ){
            item.setComment(jsonObject.get("comment").toString());
        }
        if(jsonObject.containsKey("companyScaleCode")   ){
            item.setCompanyScaleCode(jsonObject.get("companyScaleCode").toString());
        }
        if(jsonObject.containsKey("companyScaleName")   ){
            item.setCompanyScaleName(jsonObject.get("companyScaleName").toString());
        }
        if(jsonObject.containsKey("professionCode")   ){
            item.setProfessionCode(jsonObject.get("professionCode").toString());
        }
        if(jsonObject.containsKey("professionName")   ){
            item.setProfessionName(jsonObject.get("professionName").toString());
        }
        if(jsonObject.containsKey("created")   ){
            item.setCreated(Tools.convertStringToDate(jsonObject.get("created").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("updated")   ){
            item.setUpdated(Tools.convertStringToDate(jsonObject.get("updated").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("solvedTime")   ){
            item.setSolvedTime(Tools.convertStringToDate(jsonObject.get("solvedTime").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
             tEnterService.create(item);
             lists.add(tEnterService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TEnter'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_enters/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTEnter(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TEnter item = tEnterService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tEnterService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
