package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TPlatformRedpacket;
import com.haomostudio.so.service.TPlatformRedpacketService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TPlatformRedpacket")
@Controller
public class TPlatformRedpacketController {

    @Autowired
    TPlatformRedpacketService tPlatformRedpacketService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TPlatformRedpacket'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_platform_redpackets/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTPlatformRedpacket(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "mchBillno", required = false) String mchBillno,
            @RequestParam(value = "sendName", required = false) String sendName,
            @RequestParam(value = "reOpenid", required = false) String reOpenid,
            @RequestParam(value = "totalAmount", required = false) Integer totalAmount,
            @RequestParam(value = "totalNum", required = false) Integer totalNum,
            @RequestParam(value = "wishing", required = false) String wishing,
            @RequestParam(value = "clientIp", required = false) String clientIp,
            @RequestParam(value = "actName", required = false) String actName,
            @RequestParam(value = "remark", required = false) String remark,
            @RequestParam(value = "wxappid", required = false) String wxappid,
            @RequestParam(value = "sceneId", required = false) String sceneId,
            @RequestParam(value = "riskInfo", required = false) String riskInfo,
            @RequestParam(value = "consumeMchId", required = false) String consumeMchId,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "errorMsg", required = false) String errorMsg,
            @RequestParam(value = "requestNo", required = false) String requestNo,
            @RequestParam(value = "responseNo", required = false) String responseNo,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated
    ) {
        TPlatformRedpacket item = new TPlatformRedpacket();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( mchBillno != null ){
            item.setMchBillno(mchBillno);
        }
        if( sendName != null ){
            item.setSendName(sendName);
        }
        if( reOpenid != null ){
            item.setReOpenid(reOpenid);
        }
        if( totalAmount != null ){
            item.setTotalAmount(totalAmount);
        }
        if( totalNum != null ){
            item.setTotalNum(totalNum);
        }
        if( wishing != null ){
            item.setWishing(wishing);
        }
        if( clientIp != null ){
            item.setClientIp(clientIp);
        }
        if( actName != null ){
            item.setActName(actName);
        }
        if( remark != null ){
            item.setRemark(remark);
        }
        if( wxappid != null ){
            item.setWxappid(wxappid);
        }
        if( sceneId != null ){
            item.setSceneId(sceneId);
        }
        if( riskInfo != null ){
            item.setRiskInfo(riskInfo);
        }
        if( consumeMchId != null ){
            item.setConsumeMchId(consumeMchId);
        }
        if( status != null ){
            item.setStatus(status);
        }
        if( errorMsg != null ){
            item.setErrorMsg(errorMsg);
        }
        if( requestNo != null ){
            item.setRequestNo(requestNo);
        }
        if( responseNo != null ){
            item.setResponseNo(responseNo);
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        if( updated != null ){
            item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
        }
        tPlatformRedpacketService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tPlatformRedpacketService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TPlatformRedpacket'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_platform_redpackets/{t_platform_redpacket_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTPlatformRedpacket(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_redpacket_id") Integer id
    ) {
        TPlatformRedpacket item = tPlatformRedpacketService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tPlatformRedpacketService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TPlatformRedpacket'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_platform_redpackets/{t_platform_redpacket_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTPlatformRedpacket(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_redpacket_id") Integer id,
            @RequestParam(value = "mchBillno", required = false) String mchBillno,
            @RequestParam(value = "sendName", required = false) String sendName,
            @RequestParam(value = "reOpenid", required = false) String reOpenid,
            @RequestParam(value = "totalAmount", required = false) Integer totalAmount,
            @RequestParam(value = "totalNum", required = false) Integer totalNum,
            @RequestParam(value = "wishing", required = false) String wishing,
            @RequestParam(value = "clientIp", required = false) String clientIp,
            @RequestParam(value = "actName", required = false) String actName,
            @RequestParam(value = "remark", required = false) String remark,
            @RequestParam(value = "wxappid", required = false) String wxappid,
            @RequestParam(value = "sceneId", required = false) String sceneId,
            @RequestParam(value = "riskInfo", required = false) String riskInfo,
            @RequestParam(value = "consumeMchId", required = false) String consumeMchId,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "errorMsg", required = false) String errorMsg,
            @RequestParam(value = "requestNo", required = false) String requestNo,
            @RequestParam(value = "responseNo", required = false) String responseNo,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated
    ) {
        TPlatformRedpacket item = tPlatformRedpacketService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( mchBillno != null ){
            item.setMchBillno(mchBillno);
        }
        if( sendName != null ){
            item.setSendName(sendName);
        }
        if( reOpenid != null ){
            item.setReOpenid(reOpenid);
        }
        if( totalAmount != null ){
            item.setTotalAmount(totalAmount);
        }
        if( totalNum != null ){
            item.setTotalNum(totalNum);
        }
        if( wishing != null ){
            item.setWishing(wishing);
        }
        if( clientIp != null ){
            item.setClientIp(clientIp);
        }
        if( actName != null ){
            item.setActName(actName);
        }
        if( remark != null ){
            item.setRemark(remark);
        }
        if( wxappid != null ){
            item.setWxappid(wxappid);
        }
        if( sceneId != null ){
            item.setSceneId(sceneId);
        }
        if( riskInfo != null ){
            item.setRiskInfo(riskInfo);
        }
        if( consumeMchId != null ){
            item.setConsumeMchId(consumeMchId);
        }
        if( status != null ){
            item.setStatus(status);
        }
        if( errorMsg != null ){
            item.setErrorMsg(errorMsg);
        }
        if( requestNo != null ){
            item.setRequestNo(requestNo);
        }
        if( responseNo != null ){
            item.setResponseNo(responseNo);
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        if( updated != null ){
            item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
        }
        tPlatformRedpacketService.update(item);

        return tPlatformRedpacketService.get(id);
    }

    @ApiOperation(value = "查询'TPlatformRedpacket'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_platform_redpackets/{t_platform_redpacket_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformRedpacket(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_redpacket_id") Integer id,
            @RequestParam(value = "mchBillno", required = false) String mchBillno,
            @RequestParam(value = "sendName", required = false) String sendName,
            @RequestParam(value = "reOpenid", required = false) String reOpenid,
            @RequestParam(value = "totalAmount", required = false) Integer totalAmount,
            @RequestParam(value = "totalNum", required = false) Integer totalNum,
            @RequestParam(value = "wishing", required = false) String wishing,
            @RequestParam(value = "clientIp", required = false) String clientIp,
            @RequestParam(value = "actName", required = false) String actName,
            @RequestParam(value = "remark", required = false) String remark,
            @RequestParam(value = "wxappid", required = false) String wxappid,
            @RequestParam(value = "sceneId", required = false) String sceneId,
            @RequestParam(value = "riskInfo", required = false) String riskInfo,
            @RequestParam(value = "consumeMchId", required = false) String consumeMchId,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "errorMsg", required = false) String errorMsg,
            @RequestParam(value = "requestNo", required = false) String requestNo,
            @RequestParam(value = "responseNo", required = false) String responseNo,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated
    ) {
        if(request.getMethod().equals("GET")){
            TPlatformRedpacket item = tPlatformRedpacketService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TPlatformRedpacket item = tPlatformRedpacketService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( mchBillno != null ){
                item.setMchBillno(mchBillno);
            }
            if( sendName != null ){
                item.setSendName(sendName);
            }
            if( reOpenid != null ){
                item.setReOpenid(reOpenid);
            }
            if( totalAmount != null ){
                item.setTotalAmount(totalAmount);
            }
            if( totalNum != null ){
                item.setTotalNum(totalNum);
            }
            if( wishing != null ){
                item.setWishing(wishing);
            }
            if( clientIp != null ){
                item.setClientIp(clientIp);
            }
            if( actName != null ){
                item.setActName(actName);
            }
            if( remark != null ){
                item.setRemark(remark);
            }
            if( wxappid != null ){
                item.setWxappid(wxappid);
            }
            if( sceneId != null ){
                item.setSceneId(sceneId);
            }
            if( riskInfo != null ){
                item.setRiskInfo(riskInfo);
            }
            if( consumeMchId != null ){
                item.setConsumeMchId(consumeMchId);
            }
            if( status != null ){
                item.setStatus(status);
            }
            if( errorMsg != null ){
                item.setErrorMsg(errorMsg);
            }
            if( requestNo != null ){
                item.setRequestNo(requestNo);
            }
            if( responseNo != null ){
                item.setResponseNo(responseNo);
            }
            if( created != null ){
                item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
            }
            if( updated != null ){
                item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
            }
            tPlatformRedpacketService.update(item);

            return tPlatformRedpacketService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TPlatformRedpacket item = tPlatformRedpacketService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tPlatformRedpacketService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TPlatformRedpacket'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_platform_redpackets",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformRedpackets(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tPlatformRedpacketService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tPlatformRedpacketService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_platform_redpackets/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformRedpacketsId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TPlatformRedpacket> list = tPlatformRedpacketService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TPlatformRedpacket.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TPlatformRedpacket'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_platform_redpackets/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTPlatformRedpackets(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TPlatformRedpacket> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TPlatformRedpacket item = new TPlatformRedpacket();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("mchBillno")   ){
            item.setMchBillno(jsonObject.get("mchBillno").toString());
        }
        if(jsonObject.containsKey("sendName")   ){
            item.setSendName(jsonObject.get("sendName").toString());
        }
        if(jsonObject.containsKey("reOpenid")   ){
            item.setReOpenid(jsonObject.get("reOpenid").toString());
        }
        if(jsonObject.containsKey("totalAmount")   ){
            item.setTotalAmount(Integer.valueOf(jsonObject.get("totalAmount").toString()));
        }
        if(jsonObject.containsKey("totalNum")   ){
            item.setTotalNum(Integer.valueOf(jsonObject.get("totalNum").toString()));
        }
        if(jsonObject.containsKey("wishing")   ){
            item.setWishing(jsonObject.get("wishing").toString());
        }
        if(jsonObject.containsKey("clientIp")   ){
            item.setClientIp(jsonObject.get("clientIp").toString());
        }
        if(jsonObject.containsKey("actName")   ){
            item.setActName(jsonObject.get("actName").toString());
        }
        if(jsonObject.containsKey("remark")   ){
            item.setRemark(jsonObject.get("remark").toString());
        }
        if(jsonObject.containsKey("wxappid")   ){
            item.setWxappid(jsonObject.get("wxappid").toString());
        }
        if(jsonObject.containsKey("sceneId")   ){
            item.setSceneId(jsonObject.get("sceneId").toString());
        }
        if(jsonObject.containsKey("riskInfo")   ){
            item.setRiskInfo(jsonObject.get("riskInfo").toString());
        }
        if(jsonObject.containsKey("consumeMchId")   ){
            item.setConsumeMchId(jsonObject.get("consumeMchId").toString());
        }
        if(jsonObject.containsKey("status")   ){
            item.setStatus(Integer.valueOf(jsonObject.get("status").toString()));
        }
        if(jsonObject.containsKey("errorMsg")   ){
            item.setErrorMsg(jsonObject.get("errorMsg").toString());
        }
        if(jsonObject.containsKey("requestNo")   ){
            item.setRequestNo(jsonObject.get("requestNo").toString());
        }
        if(jsonObject.containsKey("responseNo")   ){
            item.setResponseNo(jsonObject.get("responseNo").toString());
        }
        if(jsonObject.containsKey("created")   ){
            item.setCreated(Tools.convertStringToDate(jsonObject.get("created").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("updated")   ){
            item.setUpdated(Tools.convertStringToDate(jsonObject.get("updated").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
             tPlatformRedpacketService.create(item);
             lists.add(tPlatformRedpacketService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TPlatformRedpacket'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_platform_redpackets/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTPlatformRedpacket(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TPlatformRedpacket item = tPlatformRedpacketService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tPlatformRedpacketService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
