package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TPlatformSelection;
import com.haomostudio.so.service.TPlatformSelectionService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TPlatformSelection")
@Controller
public class TPlatformSelectionController {

    @Autowired
    TPlatformSelectionService tPlatformSelectionService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TPlatformSelection'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_platform_selections/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTPlatformSelection(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "title", required = false) String title,
            @RequestParam(value = "subhead", required = false) String subhead,
            @RequestParam(value = "bannerPath", required = false) String bannerPath,
            @RequestParam(value = "content", required = false) String content,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "pvCount", required = false) Integer pvCount,
            @RequestParam(value = "isSelection", required = false) Integer isSelection,
            @RequestParam(value = "topTime", required = false) String topTime,
            @RequestParam(value = "isDelete", required = false) Integer isDelete,
            @RequestParam(value = "deleted", required = false) String deleted,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated,
            @RequestParam(value = "allPageView", required = false) Integer allPageView
    ) {
        TPlatformSelection item = new TPlatformSelection();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( title != null ){
            item.setTitle(title);
        }
        if( subhead != null ){
            item.setSubhead(subhead);
        }
        if( bannerPath != null ){
            item.setBannerPath(bannerPath);
        }
        if( content != null ){
            item.setContent(content);
        }
        if( status != null ){
            item.setStatus(status);
        }
        if( pvCount != null ){
            item.setPvCount(pvCount);
        }
        if( isSelection != null ){
            item.setIsSelection(isSelection);
        }
        if( topTime != null ){
            item.setTopTime(Tools.convertStringToDate(topTime, "yyyy-MM-dd HH:mm:ss"));
        }
        if( isDelete != null ){
            item.setIsDelete(isDelete);
        }
        if( deleted != null ){
            item.setDeleted(Tools.convertStringToDate(deleted, "yyyy-MM-dd HH:mm:ss"));
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        if( updated != null ){
            item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
        }
        if( allPageView != null ){
            item.setAllPageView(allPageView);
        }
        tPlatformSelectionService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tPlatformSelectionService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TPlatformSelection'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_platform_selections/{t_platform_selection_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTPlatformSelection(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_selection_id") Integer id
    ) {
        TPlatformSelection item = tPlatformSelectionService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tPlatformSelectionService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TPlatformSelection'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_platform_selections/{t_platform_selection_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTPlatformSelection(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_selection_id") Integer id,
            @RequestParam(value = "title", required = false) String title,
            @RequestParam(value = "subhead", required = false) String subhead,
            @RequestParam(value = "bannerPath", required = false) String bannerPath,
            @RequestParam(value = "content", required = false) String content,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "pvCount", required = false) Integer pvCount,
            @RequestParam(value = "isSelection", required = false) Integer isSelection,
            @RequestParam(value = "topTime", required = false) String topTime,
            @RequestParam(value = "isDelete", required = false) Integer isDelete,
            @RequestParam(value = "deleted", required = false) String deleted,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated,
            @RequestParam(value = "allPageView", required = false) Integer allPageView
    ) {
        TPlatformSelection item = tPlatformSelectionService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( title != null ){
            item.setTitle(title);
        }
        if( subhead != null ){
            item.setSubhead(subhead);
        }
        if( bannerPath != null ){
            item.setBannerPath(bannerPath);
        }
        if( content != null ){
            item.setContent(content);
        }
        if( status != null ){
            item.setStatus(status);
        }
        if( pvCount != null ){
            item.setPvCount(pvCount);
        }
        if( isSelection != null ){
            item.setIsSelection(isSelection);
        }
        if( topTime != null ){
            item.setTopTime(Tools.convertStringToDate(topTime, "yyyy-MM-dd HH:mm:ss"));
        }
        if( isDelete != null ){
            item.setIsDelete(isDelete);
        }
        if( deleted != null ){
            item.setDeleted(Tools.convertStringToDate(deleted, "yyyy-MM-dd HH:mm:ss"));
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        if( updated != null ){
            item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
        }
        if( allPageView != null ){
            item.setAllPageView(allPageView);
        }
        tPlatformSelectionService.update(item);

        return tPlatformSelectionService.get(id);
    }

    @ApiOperation(value = "查询'TPlatformSelection'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_platform_selections/{t_platform_selection_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformSelection(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_selection_id") Integer id,
            @RequestParam(value = "title", required = false) String title,
            @RequestParam(value = "subhead", required = false) String subhead,
            @RequestParam(value = "bannerPath", required = false) String bannerPath,
            @RequestParam(value = "content", required = false) String content,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "pvCount", required = false) Integer pvCount,
            @RequestParam(value = "isSelection", required = false) Integer isSelection,
            @RequestParam(value = "topTime", required = false) String topTime,
            @RequestParam(value = "isDelete", required = false) Integer isDelete,
            @RequestParam(value = "deleted", required = false) String deleted,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated,
            @RequestParam(value = "allPageView", required = false) Integer allPageView
    ) {
        if(request.getMethod().equals("GET")){
            TPlatformSelection item = tPlatformSelectionService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TPlatformSelection item = tPlatformSelectionService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( title != null ){
                item.setTitle(title);
            }
            if( subhead != null ){
                item.setSubhead(subhead);
            }
            if( bannerPath != null ){
                item.setBannerPath(bannerPath);
            }
            if( content != null ){
                item.setContent(content);
            }
            if( status != null ){
                item.setStatus(status);
            }
            if( pvCount != null ){
                item.setPvCount(pvCount);
            }
            if( isSelection != null ){
                item.setIsSelection(isSelection);
            }
            if( topTime != null ){
                item.setTopTime(Tools.convertStringToDate(topTime, "yyyy-MM-dd HH:mm:ss"));
            }
            if( isDelete != null ){
                item.setIsDelete(isDelete);
            }
            if( deleted != null ){
                item.setDeleted(Tools.convertStringToDate(deleted, "yyyy-MM-dd HH:mm:ss"));
            }
            if( created != null ){
                item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
            }
            if( updated != null ){
                item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
            }
            if( allPageView != null ){
                item.setAllPageView(allPageView);
            }
            tPlatformSelectionService.update(item);

            return tPlatformSelectionService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TPlatformSelection item = tPlatformSelectionService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tPlatformSelectionService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TPlatformSelection'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_platform_selections",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformSelections(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tPlatformSelectionService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tPlatformSelectionService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_platform_selections/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformSelectionsId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TPlatformSelection> list = tPlatformSelectionService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TPlatformSelection.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TPlatformSelection'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_platform_selections/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTPlatformSelections(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TPlatformSelection> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TPlatformSelection item = new TPlatformSelection();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("title")   ){
            item.setTitle(jsonObject.get("title").toString());
        }
        if(jsonObject.containsKey("subhead")   ){
            item.setSubhead(jsonObject.get("subhead").toString());
        }
        if(jsonObject.containsKey("bannerPath")   ){
            item.setBannerPath(jsonObject.get("bannerPath").toString());
        }
        if(jsonObject.containsKey("content")   ){
            item.setContent(jsonObject.get("content").toString());
        }
        if(jsonObject.containsKey("status")   ){
            item.setStatus(Integer.valueOf(jsonObject.get("status").toString()));
        }
        if(jsonObject.containsKey("pvCount")   ){
            item.setPvCount(Integer.valueOf(jsonObject.get("pvCount").toString()));
        }
        if(jsonObject.containsKey("isSelection")   ){
            item.setIsSelection(Integer.valueOf(jsonObject.get("isSelection").toString()));
        }
        if(jsonObject.containsKey("topTime")   ){
            item.setTopTime(Tools.convertStringToDate(jsonObject.get("topTime").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("isDelete")   ){
            item.setIsDelete(Integer.valueOf(jsonObject.get("isDelete").toString()));
        }
        if(jsonObject.containsKey("deleted")   ){
            item.setDeleted(Tools.convertStringToDate(jsonObject.get("deleted").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("created")   ){
            item.setCreated(Tools.convertStringToDate(jsonObject.get("created").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("updated")   ){
            item.setUpdated(Tools.convertStringToDate(jsonObject.get("updated").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("allPageView")   ){
            item.setAllPageView(Integer.valueOf(jsonObject.get("allPageView").toString()));
        }
             tPlatformSelectionService.create(item);
             lists.add(tPlatformSelectionService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TPlatformSelection'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_platform_selections/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTPlatformSelection(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TPlatformSelection item = tPlatformSelectionService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tPlatformSelectionService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
