package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TPlatformServiceOrder;
import com.haomostudio.so.service.TPlatformServiceOrderService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TPlatformServiceOrder")
@Controller
public class TPlatformServiceOrderController {

    @Autowired
    TPlatformServiceOrderService tPlatformServiceOrderService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TPlatformServiceOrder'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_platform_service_orders/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTPlatformServiceOrder(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "orderNum", required = false) String orderNum,
            @RequestParam(value = "customerId", required = false) Integer customerId,
            @RequestParam(value = "serviceId", required = false) Integer serviceId,
            @RequestParam(value = "serviceName", required = false) String serviceName,
            @RequestParam(value = "typeCode", required = false) Integer typeCode,
            @RequestParam(value = "typeName", required = false) String typeName,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "spaceName", required = false) String spaceName,
            @RequestParam(value = "providerId", required = false) Integer providerId,
            @RequestParam(value = "providerName", required = false) String providerName,
            @RequestParam(value = "contact", required = false) String contact,
            @RequestParam(value = "phone", required = false) String phone,
            @RequestParam(value = "content", required = false) String content,
            @RequestParam(value = "orderStatus", required = false) Integer orderStatus,
            @RequestParam(value = "createDate", required = false) String createDate,
            @RequestParam(value = "lastModifyDate", required = false) String lastModifyDate,
            @RequestParam(value = "acceptTime", required = false) String acceptTime,
            @RequestParam(value = "supervisorId", required = false) Integer supervisorId
    ) {
        TPlatformServiceOrder item = new TPlatformServiceOrder();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( orderNum != null ){
            item.setOrderNum(orderNum);
        }
        if( customerId != null ){
            item.setCustomerId(customerId);
        }
        if( serviceId != null ){
            item.setServiceId(serviceId);
        }
        if( serviceName != null ){
            item.setServiceName(serviceName);
        }
        if( typeCode != null ){
            item.setTypeCode(typeCode);
        }
        if( typeName != null ){
            item.setTypeName(typeName);
        }
        if( spaceId != null ){
            item.setSpaceId(spaceId);
        }
        if( spaceName != null ){
            item.setSpaceName(spaceName);
        }
        if( providerId != null ){
            item.setProviderId(providerId);
        }
        if( providerName != null ){
            item.setProviderName(providerName);
        }
        if( contact != null ){
            item.setContact(contact);
        }
        if( phone != null ){
            item.setPhone(phone);
        }
        if( content != null ){
            item.setContent(content);
        }
        if( orderStatus != null ){
            item.setOrderStatus(orderStatus);
        }
        if( createDate != null ){
            item.setCreateDate(Tools.convertStringToDate(createDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( lastModifyDate != null ){
            item.setLastModifyDate(Tools.convertStringToDate(lastModifyDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( acceptTime != null ){
            item.setAcceptTime(Tools.convertStringToDate(acceptTime, "yyyy-MM-dd HH:mm:ss"));
        }
        if( supervisorId != null ){
            item.setSupervisorId(supervisorId);
        }
        tPlatformServiceOrderService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tPlatformServiceOrderService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TPlatformServiceOrder'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_platform_service_orders/{t_platform_service_order_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTPlatformServiceOrder(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_service_order_id") Integer id
    ) {
        TPlatformServiceOrder item = tPlatformServiceOrderService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tPlatformServiceOrderService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TPlatformServiceOrder'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_platform_service_orders/{t_platform_service_order_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTPlatformServiceOrder(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_service_order_id") Integer id,
            @RequestParam(value = "orderNum", required = false) String orderNum,
            @RequestParam(value = "customerId", required = false) Integer customerId,
            @RequestParam(value = "serviceId", required = false) Integer serviceId,
            @RequestParam(value = "serviceName", required = false) String serviceName,
            @RequestParam(value = "typeCode", required = false) Integer typeCode,
            @RequestParam(value = "typeName", required = false) String typeName,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "spaceName", required = false) String spaceName,
            @RequestParam(value = "providerId", required = false) Integer providerId,
            @RequestParam(value = "providerName", required = false) String providerName,
            @RequestParam(value = "contact", required = false) String contact,
            @RequestParam(value = "phone", required = false) String phone,
            @RequestParam(value = "content", required = false) String content,
            @RequestParam(value = "orderStatus", required = false) Integer orderStatus,
            @RequestParam(value = "createDate", required = false) String createDate,
            @RequestParam(value = "lastModifyDate", required = false) String lastModifyDate,
            @RequestParam(value = "acceptTime", required = false) String acceptTime,
            @RequestParam(value = "supervisorId", required = false) Integer supervisorId
    ) {
        TPlatformServiceOrder item = tPlatformServiceOrderService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( orderNum != null ){
            item.setOrderNum(orderNum);
        }
        if( customerId != null ){
            item.setCustomerId(customerId);
        }
        if( serviceId != null ){
            item.setServiceId(serviceId);
        }
        if( serviceName != null ){
            item.setServiceName(serviceName);
        }
        if( typeCode != null ){
            item.setTypeCode(typeCode);
        }
        if( typeName != null ){
            item.setTypeName(typeName);
        }
        if( spaceId != null ){
            item.setSpaceId(spaceId);
        }
        if( spaceName != null ){
            item.setSpaceName(spaceName);
        }
        if( providerId != null ){
            item.setProviderId(providerId);
        }
        if( providerName != null ){
            item.setProviderName(providerName);
        }
        if( contact != null ){
            item.setContact(contact);
        }
        if( phone != null ){
            item.setPhone(phone);
        }
        if( content != null ){
            item.setContent(content);
        }
        if( orderStatus != null ){
            item.setOrderStatus(orderStatus);
        }
        if( createDate != null ){
            item.setCreateDate(Tools.convertStringToDate(createDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( lastModifyDate != null ){
            item.setLastModifyDate(Tools.convertStringToDate(lastModifyDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( acceptTime != null ){
            item.setAcceptTime(Tools.convertStringToDate(acceptTime, "yyyy-MM-dd HH:mm:ss"));
        }
        if( supervisorId != null ){
            item.setSupervisorId(supervisorId);
        }
        tPlatformServiceOrderService.update(item);

        return tPlatformServiceOrderService.get(id);
    }

    @ApiOperation(value = "查询'TPlatformServiceOrder'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_platform_service_orders/{t_platform_service_order_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformServiceOrder(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_service_order_id") Integer id,
            @RequestParam(value = "orderNum", required = false) String orderNum,
            @RequestParam(value = "customerId", required = false) Integer customerId,
            @RequestParam(value = "serviceId", required = false) Integer serviceId,
            @RequestParam(value = "serviceName", required = false) String serviceName,
            @RequestParam(value = "typeCode", required = false) Integer typeCode,
            @RequestParam(value = "typeName", required = false) String typeName,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "spaceName", required = false) String spaceName,
            @RequestParam(value = "providerId", required = false) Integer providerId,
            @RequestParam(value = "providerName", required = false) String providerName,
            @RequestParam(value = "contact", required = false) String contact,
            @RequestParam(value = "phone", required = false) String phone,
            @RequestParam(value = "content", required = false) String content,
            @RequestParam(value = "orderStatus", required = false) Integer orderStatus,
            @RequestParam(value = "createDate", required = false) String createDate,
            @RequestParam(value = "lastModifyDate", required = false) String lastModifyDate,
            @RequestParam(value = "acceptTime", required = false) String acceptTime,
            @RequestParam(value = "supervisorId", required = false) Integer supervisorId
    ) {
        if(request.getMethod().equals("GET")){
            TPlatformServiceOrder item = tPlatformServiceOrderService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TPlatformServiceOrder item = tPlatformServiceOrderService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( orderNum != null ){
                item.setOrderNum(orderNum);
            }
            if( customerId != null ){
                item.setCustomerId(customerId);
            }
            if( serviceId != null ){
                item.setServiceId(serviceId);
            }
            if( serviceName != null ){
                item.setServiceName(serviceName);
            }
            if( typeCode != null ){
                item.setTypeCode(typeCode);
            }
            if( typeName != null ){
                item.setTypeName(typeName);
            }
            if( spaceId != null ){
                item.setSpaceId(spaceId);
            }
            if( spaceName != null ){
                item.setSpaceName(spaceName);
            }
            if( providerId != null ){
                item.setProviderId(providerId);
            }
            if( providerName != null ){
                item.setProviderName(providerName);
            }
            if( contact != null ){
                item.setContact(contact);
            }
            if( phone != null ){
                item.setPhone(phone);
            }
            if( content != null ){
                item.setContent(content);
            }
            if( orderStatus != null ){
                item.setOrderStatus(orderStatus);
            }
            if( createDate != null ){
                item.setCreateDate(Tools.convertStringToDate(createDate, "yyyy-MM-dd HH:mm:ss"));
            }
            if( lastModifyDate != null ){
                item.setLastModifyDate(Tools.convertStringToDate(lastModifyDate, "yyyy-MM-dd HH:mm:ss"));
            }
            if( acceptTime != null ){
                item.setAcceptTime(Tools.convertStringToDate(acceptTime, "yyyy-MM-dd HH:mm:ss"));
            }
            if( supervisorId != null ){
                item.setSupervisorId(supervisorId);
            }
            tPlatformServiceOrderService.update(item);

            return tPlatformServiceOrderService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TPlatformServiceOrder item = tPlatformServiceOrderService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tPlatformServiceOrderService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TPlatformServiceOrder'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_platform_service_orders",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformServiceOrders(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tPlatformServiceOrderService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tPlatformServiceOrderService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_platform_service_orders/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformServiceOrdersId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TPlatformServiceOrder> list = tPlatformServiceOrderService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TPlatformServiceOrder.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TPlatformServiceOrder'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_platform_service_orders/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTPlatformServiceOrders(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TPlatformServiceOrder> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TPlatformServiceOrder item = new TPlatformServiceOrder();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("orderNum")   ){
            item.setOrderNum(jsonObject.get("orderNum").toString());
        }
        if(jsonObject.containsKey("customerId")   ){
            item.setCustomerId(Integer.valueOf(jsonObject.get("customerId").toString()));
        }
        if(jsonObject.containsKey("serviceId")   ){
            item.setServiceId(Integer.valueOf(jsonObject.get("serviceId").toString()));
        }
        if(jsonObject.containsKey("serviceName")   ){
            item.setServiceName(jsonObject.get("serviceName").toString());
        }
        if(jsonObject.containsKey("typeCode")   ){
            item.setTypeCode(Integer.valueOf(jsonObject.get("typeCode").toString()));
        }
        if(jsonObject.containsKey("typeName")   ){
            item.setTypeName(jsonObject.get("typeName").toString());
        }
        if(jsonObject.containsKey("spaceId")   ){
            item.setSpaceId(Integer.valueOf(jsonObject.get("spaceId").toString()));
        }
        if(jsonObject.containsKey("spaceName")   ){
            item.setSpaceName(jsonObject.get("spaceName").toString());
        }
        if(jsonObject.containsKey("providerId")   ){
            item.setProviderId(Integer.valueOf(jsonObject.get("providerId").toString()));
        }
        if(jsonObject.containsKey("providerName")   ){
            item.setProviderName(jsonObject.get("providerName").toString());
        }
        if(jsonObject.containsKey("contact")   ){
            item.setContact(jsonObject.get("contact").toString());
        }
        if(jsonObject.containsKey("phone")   ){
            item.setPhone(jsonObject.get("phone").toString());
        }
        if(jsonObject.containsKey("content")   ){
            item.setContent(jsonObject.get("content").toString());
        }
        if(jsonObject.containsKey("orderStatus")   ){
            item.setOrderStatus(Integer.valueOf(jsonObject.get("orderStatus").toString()));
        }
        if(jsonObject.containsKey("createDate")   ){
            item.setCreateDate(Tools.convertStringToDate(jsonObject.get("createDate").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("lastModifyDate")   ){
            item.setLastModifyDate(Tools.convertStringToDate(jsonObject.get("lastModifyDate").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("acceptTime")   ){
            item.setAcceptTime(Tools.convertStringToDate(jsonObject.get("acceptTime").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("supervisorId")   ){
            item.setSupervisorId(Integer.valueOf(jsonObject.get("supervisorId").toString()));
        }
             tPlatformServiceOrderService.create(item);
             lists.add(tPlatformServiceOrderService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TPlatformServiceOrder'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_platform_service_orders/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTPlatformServiceOrder(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TPlatformServiceOrder item = tPlatformServiceOrderService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tPlatformServiceOrderService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
