package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TPlatformWeixinPayNotify;
import com.haomostudio.so.service.TPlatformWeixinPayNotifyService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TPlatformWeixinPayNotify")
@Controller
public class TPlatformWeixinPayNotifyController {

    @Autowired
    TPlatformWeixinPayNotifyService tPlatformWeixinPayNotifyService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TPlatformWeixinPayNotify'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_platform_weixin_pay_notifies/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTPlatformWeixinPayNotify(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "returnCode", required = false) String returnCode,
            @RequestParam(value = "appId", required = false) String appId,
            @RequestParam(value = "mchId", required = false) String mchId,
            @RequestParam(value = "resultCode", required = false) String resultCode,
            @RequestParam(value = "openId", required = false) String openId,
            @RequestParam(value = "tradeType", required = false) String tradeType,
            @RequestParam(value = "bankType", required = false) String bankType,
            @RequestParam(value = "totalFee", required = false) Integer totalFee,
            @RequestParam(value = "settlementTotalFee", required = false) Integer settlementTotalFee,
            @RequestParam(value = "cashFee", required = false) Integer cashFee,
            @RequestParam(value = "couponFee", required = false) Integer couponFee,
            @RequestParam(value = "transactionId", required = false) String transactionId,
            @RequestParam(value = "outTradeNo", required = false) String outTradeNo,
            @RequestParam(value = "attach", required = false) String attach,
            @RequestParam(value = "timeEnd", required = false) String timeEnd,
            @RequestParam(value = "notifyXml", required = false) String notifyXml,
            @RequestParam(value = "platformWeixinPayUnifiedOrderReqId", required = false) Integer platformWeixinPayUnifiedOrderReqId,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated
    ) {
        TPlatformWeixinPayNotify item = new TPlatformWeixinPayNotify();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( returnCode != null ){
            item.setReturnCode(returnCode);
        }
        if( appId != null ){
            item.setAppId(appId);
        }
        if( mchId != null ){
            item.setMchId(mchId);
        }
        if( resultCode != null ){
            item.setResultCode(resultCode);
        }
        if( openId != null ){
            item.setOpenId(openId);
        }
        if( tradeType != null ){
            item.setTradeType(tradeType);
        }
        if( bankType != null ){
            item.setBankType(bankType);
        }
        if( totalFee != null ){
            item.setTotalFee(totalFee);
        }
        if( settlementTotalFee != null ){
            item.setSettlementTotalFee(settlementTotalFee);
        }
        if( cashFee != null ){
            item.setCashFee(cashFee);
        }
        if( couponFee != null ){
            item.setCouponFee(couponFee);
        }
        if( transactionId != null ){
            item.setTransactionId(transactionId);
        }
        if( outTradeNo != null ){
            item.setOutTradeNo(outTradeNo);
        }
        if( attach != null ){
            item.setAttach(attach);
        }
        if( timeEnd != null ){
            item.setTimeEnd(timeEnd);
        }
        if( notifyXml != null ){
            item.setNotifyXml(notifyXml);
        }
        if( platformWeixinPayUnifiedOrderReqId != null ){
            item.setPlatformWeixinPayUnifiedOrderReqId(platformWeixinPayUnifiedOrderReqId);
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        if( updated != null ){
            item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
        }
        tPlatformWeixinPayNotifyService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tPlatformWeixinPayNotifyService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TPlatformWeixinPayNotify'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_platform_weixin_pay_notifies/{t_platform_weixin_pay_notify_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTPlatformWeixinPayNotify(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_weixin_pay_notify_id") Integer id
    ) {
        TPlatformWeixinPayNotify item = tPlatformWeixinPayNotifyService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tPlatformWeixinPayNotifyService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TPlatformWeixinPayNotify'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_platform_weixin_pay_notifies/{t_platform_weixin_pay_notify_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTPlatformWeixinPayNotify(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_weixin_pay_notify_id") Integer id,
            @RequestParam(value = "returnCode", required = false) String returnCode,
            @RequestParam(value = "appId", required = false) String appId,
            @RequestParam(value = "mchId", required = false) String mchId,
            @RequestParam(value = "resultCode", required = false) String resultCode,
            @RequestParam(value = "openId", required = false) String openId,
            @RequestParam(value = "tradeType", required = false) String tradeType,
            @RequestParam(value = "bankType", required = false) String bankType,
            @RequestParam(value = "totalFee", required = false) Integer totalFee,
            @RequestParam(value = "settlementTotalFee", required = false) Integer settlementTotalFee,
            @RequestParam(value = "cashFee", required = false) Integer cashFee,
            @RequestParam(value = "couponFee", required = false) Integer couponFee,
            @RequestParam(value = "transactionId", required = false) String transactionId,
            @RequestParam(value = "outTradeNo", required = false) String outTradeNo,
            @RequestParam(value = "attach", required = false) String attach,
            @RequestParam(value = "timeEnd", required = false) String timeEnd,
            @RequestParam(value = "notifyXml", required = false) String notifyXml,
            @RequestParam(value = "platformWeixinPayUnifiedOrderReqId", required = false) Integer platformWeixinPayUnifiedOrderReqId,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated
    ) {
        TPlatformWeixinPayNotify item = tPlatformWeixinPayNotifyService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( returnCode != null ){
            item.setReturnCode(returnCode);
        }
        if( appId != null ){
            item.setAppId(appId);
        }
        if( mchId != null ){
            item.setMchId(mchId);
        }
        if( resultCode != null ){
            item.setResultCode(resultCode);
        }
        if( openId != null ){
            item.setOpenId(openId);
        }
        if( tradeType != null ){
            item.setTradeType(tradeType);
        }
        if( bankType != null ){
            item.setBankType(bankType);
        }
        if( totalFee != null ){
            item.setTotalFee(totalFee);
        }
        if( settlementTotalFee != null ){
            item.setSettlementTotalFee(settlementTotalFee);
        }
        if( cashFee != null ){
            item.setCashFee(cashFee);
        }
        if( couponFee != null ){
            item.setCouponFee(couponFee);
        }
        if( transactionId != null ){
            item.setTransactionId(transactionId);
        }
        if( outTradeNo != null ){
            item.setOutTradeNo(outTradeNo);
        }
        if( attach != null ){
            item.setAttach(attach);
        }
        if( timeEnd != null ){
            item.setTimeEnd(timeEnd);
        }
        if( notifyXml != null ){
            item.setNotifyXml(notifyXml);
        }
        if( platformWeixinPayUnifiedOrderReqId != null ){
            item.setPlatformWeixinPayUnifiedOrderReqId(platformWeixinPayUnifiedOrderReqId);
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        if( updated != null ){
            item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
        }
        tPlatformWeixinPayNotifyService.update(item);

        return tPlatformWeixinPayNotifyService.get(id);
    }

    @ApiOperation(value = "查询'TPlatformWeixinPayNotify'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_platform_weixin_pay_notifies/{t_platform_weixin_pay_notify_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformWeixinPayNotify(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_weixin_pay_notify_id") Integer id,
            @RequestParam(value = "returnCode", required = false) String returnCode,
            @RequestParam(value = "appId", required = false) String appId,
            @RequestParam(value = "mchId", required = false) String mchId,
            @RequestParam(value = "resultCode", required = false) String resultCode,
            @RequestParam(value = "openId", required = false) String openId,
            @RequestParam(value = "tradeType", required = false) String tradeType,
            @RequestParam(value = "bankType", required = false) String bankType,
            @RequestParam(value = "totalFee", required = false) Integer totalFee,
            @RequestParam(value = "settlementTotalFee", required = false) Integer settlementTotalFee,
            @RequestParam(value = "cashFee", required = false) Integer cashFee,
            @RequestParam(value = "couponFee", required = false) Integer couponFee,
            @RequestParam(value = "transactionId", required = false) String transactionId,
            @RequestParam(value = "outTradeNo", required = false) String outTradeNo,
            @RequestParam(value = "attach", required = false) String attach,
            @RequestParam(value = "timeEnd", required = false) String timeEnd,
            @RequestParam(value = "notifyXml", required = false) String notifyXml,
            @RequestParam(value = "platformWeixinPayUnifiedOrderReqId", required = false) Integer platformWeixinPayUnifiedOrderReqId,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated
    ) {
        if(request.getMethod().equals("GET")){
            TPlatformWeixinPayNotify item = tPlatformWeixinPayNotifyService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TPlatformWeixinPayNotify item = tPlatformWeixinPayNotifyService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( returnCode != null ){
                item.setReturnCode(returnCode);
            }
            if( appId != null ){
                item.setAppId(appId);
            }
            if( mchId != null ){
                item.setMchId(mchId);
            }
            if( resultCode != null ){
                item.setResultCode(resultCode);
            }
            if( openId != null ){
                item.setOpenId(openId);
            }
            if( tradeType != null ){
                item.setTradeType(tradeType);
            }
            if( bankType != null ){
                item.setBankType(bankType);
            }
            if( totalFee != null ){
                item.setTotalFee(totalFee);
            }
            if( settlementTotalFee != null ){
                item.setSettlementTotalFee(settlementTotalFee);
            }
            if( cashFee != null ){
                item.setCashFee(cashFee);
            }
            if( couponFee != null ){
                item.setCouponFee(couponFee);
            }
            if( transactionId != null ){
                item.setTransactionId(transactionId);
            }
            if( outTradeNo != null ){
                item.setOutTradeNo(outTradeNo);
            }
            if( attach != null ){
                item.setAttach(attach);
            }
            if( timeEnd != null ){
                item.setTimeEnd(timeEnd);
            }
            if( notifyXml != null ){
                item.setNotifyXml(notifyXml);
            }
            if( platformWeixinPayUnifiedOrderReqId != null ){
                item.setPlatformWeixinPayUnifiedOrderReqId(platformWeixinPayUnifiedOrderReqId);
            }
            if( created != null ){
                item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
            }
            if( updated != null ){
                item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
            }
            tPlatformWeixinPayNotifyService.update(item);

            return tPlatformWeixinPayNotifyService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TPlatformWeixinPayNotify item = tPlatformWeixinPayNotifyService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tPlatformWeixinPayNotifyService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TPlatformWeixinPayNotify'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_platform_weixin_pay_notifies",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformWeixinPayNotifies(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tPlatformWeixinPayNotifyService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tPlatformWeixinPayNotifyService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_platform_weixin_pay_notifies/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformWeixinPayNotifiesId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TPlatformWeixinPayNotify> list = tPlatformWeixinPayNotifyService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TPlatformWeixinPayNotify.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TPlatformWeixinPayNotify'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_platform_weixin_pay_notifies/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTPlatformWeixinPayNotifies(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TPlatformWeixinPayNotify> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TPlatformWeixinPayNotify item = new TPlatformWeixinPayNotify();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("returnCode")   ){
            item.setReturnCode(jsonObject.get("returnCode").toString());
        }
        if(jsonObject.containsKey("appId")   ){
            item.setAppId(jsonObject.get("appId").toString());
        }
        if(jsonObject.containsKey("mchId")   ){
            item.setMchId(jsonObject.get("mchId").toString());
        }
        if(jsonObject.containsKey("resultCode")   ){
            item.setResultCode(jsonObject.get("resultCode").toString());
        }
        if(jsonObject.containsKey("openId")   ){
            item.setOpenId(jsonObject.get("openId").toString());
        }
        if(jsonObject.containsKey("tradeType")   ){
            item.setTradeType(jsonObject.get("tradeType").toString());
        }
        if(jsonObject.containsKey("bankType")   ){
            item.setBankType(jsonObject.get("bankType").toString());
        }
        if(jsonObject.containsKey("totalFee")   ){
            item.setTotalFee(Integer.valueOf(jsonObject.get("totalFee").toString()));
        }
        if(jsonObject.containsKey("settlementTotalFee")   ){
            item.setSettlementTotalFee(Integer.valueOf(jsonObject.get("settlementTotalFee").toString()));
        }
        if(jsonObject.containsKey("cashFee")   ){
            item.setCashFee(Integer.valueOf(jsonObject.get("cashFee").toString()));
        }
        if(jsonObject.containsKey("couponFee")   ){
            item.setCouponFee(Integer.valueOf(jsonObject.get("couponFee").toString()));
        }
        if(jsonObject.containsKey("transactionId")   ){
            item.setTransactionId(jsonObject.get("transactionId").toString());
        }
        if(jsonObject.containsKey("outTradeNo")   ){
            item.setOutTradeNo(jsonObject.get("outTradeNo").toString());
        }
        if(jsonObject.containsKey("attach")   ){
            item.setAttach(jsonObject.get("attach").toString());
        }
        if(jsonObject.containsKey("timeEnd")   ){
            item.setTimeEnd(jsonObject.get("timeEnd").toString());
        }
        if(jsonObject.containsKey("notifyXml")   ){
            item.setNotifyXml(jsonObject.get("notifyXml").toString());
        }
        if(jsonObject.containsKey("platformWeixinPayUnifiedOrderReqId")   ){
            item.setPlatformWeixinPayUnifiedOrderReqId(Integer.valueOf(jsonObject.get("platformWeixinPayUnifiedOrderReqId").toString()));
        }
        if(jsonObject.containsKey("created")   ){
            item.setCreated(Tools.convertStringToDate(jsonObject.get("created").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("updated")   ){
            item.setUpdated(Tools.convertStringToDate(jsonObject.get("updated").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
             tPlatformWeixinPayNotifyService.create(item);
             lists.add(tPlatformWeixinPayNotifyService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TPlatformWeixinPayNotify'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_platform_weixin_pay_notifies/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTPlatformWeixinPayNotify(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TPlatformWeixinPayNotify item = tPlatformWeixinPayNotifyService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tPlatformWeixinPayNotifyService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
