package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TPlatformWeixinPayUnifiedOrderResp;
import com.haomostudio.so.service.TPlatformWeixinPayUnifiedOrderRespService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TPlatformWeixinPayUnifiedOrderResp")
@Controller
public class TPlatformWeixinPayUnifiedOrderRespController {

    @Autowired
    TPlatformWeixinPayUnifiedOrderRespService tPlatformWeixinPayUnifiedOrderRespService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TPlatformWeixinPayUnifiedOrderResp'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_platform_weixin_pay_unified_order_resps/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTPlatformWeixinPayUnifiedOrderResp(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "platformWeixinPayUnifiedOrderReqId", required = false) Integer platformWeixinPayUnifiedOrderReqId,
            @RequestParam(value = "returnCode", required = false) String returnCode,
            @RequestParam(value = "appId", required = false) String appId,
            @RequestParam(value = "mchId", required = false) String mchId,
            @RequestParam(value = "resultCode", required = false) String resultCode,
            @RequestParam(value = "tradeType", required = false) String tradeType,
            @RequestParam(value = "prepayId", required = false) String prepayId,
            @RequestParam(value = "codeUrl", required = false) String codeUrl,
            @RequestParam(value = "prepayNo", required = false) String prepayNo,
            @RequestParam(value = "responseXml", required = false) String responseXml
    ) {
        TPlatformWeixinPayUnifiedOrderResp item = new TPlatformWeixinPayUnifiedOrderResp();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( platformWeixinPayUnifiedOrderReqId != null ){
            item.setPlatformWeixinPayUnifiedOrderReqId(platformWeixinPayUnifiedOrderReqId);
        }
        if( returnCode != null ){
            item.setReturnCode(returnCode);
        }
        if( appId != null ){
            item.setAppId(appId);
        }
        if( mchId != null ){
            item.setMchId(mchId);
        }
        if( resultCode != null ){
            item.setResultCode(resultCode);
        }
        if( tradeType != null ){
            item.setTradeType(tradeType);
        }
        if( prepayId != null ){
            item.setPrepayId(prepayId);
        }
        if( codeUrl != null ){
            item.setCodeUrl(codeUrl);
        }
        if( prepayNo != null ){
            item.setPrepayNo(prepayNo);
        }
        if( responseXml != null ){
            item.setResponseXml(responseXml);
        }
        tPlatformWeixinPayUnifiedOrderRespService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tPlatformWeixinPayUnifiedOrderRespService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TPlatformWeixinPayUnifiedOrderResp'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_platform_weixin_pay_unified_order_resps/{t_platform_weixin_pay_unified_order_resp_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTPlatformWeixinPayUnifiedOrderResp(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_weixin_pay_unified_order_resp_id") Integer id
    ) {
        TPlatformWeixinPayUnifiedOrderResp item = tPlatformWeixinPayUnifiedOrderRespService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tPlatformWeixinPayUnifiedOrderRespService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TPlatformWeixinPayUnifiedOrderResp'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_platform_weixin_pay_unified_order_resps/{t_platform_weixin_pay_unified_order_resp_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTPlatformWeixinPayUnifiedOrderResp(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_weixin_pay_unified_order_resp_id") Integer id,
            @RequestParam(value = "platformWeixinPayUnifiedOrderReqId", required = false) Integer platformWeixinPayUnifiedOrderReqId,
            @RequestParam(value = "returnCode", required = false) String returnCode,
            @RequestParam(value = "appId", required = false) String appId,
            @RequestParam(value = "mchId", required = false) String mchId,
            @RequestParam(value = "resultCode", required = false) String resultCode,
            @RequestParam(value = "tradeType", required = false) String tradeType,
            @RequestParam(value = "prepayId", required = false) String prepayId,
            @RequestParam(value = "codeUrl", required = false) String codeUrl,
            @RequestParam(value = "prepayNo", required = false) String prepayNo,
            @RequestParam(value = "responseXml", required = false) String responseXml
    ) {
        TPlatformWeixinPayUnifiedOrderResp item = tPlatformWeixinPayUnifiedOrderRespService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( platformWeixinPayUnifiedOrderReqId != null ){
            item.setPlatformWeixinPayUnifiedOrderReqId(platformWeixinPayUnifiedOrderReqId);
        }
        if( returnCode != null ){
            item.setReturnCode(returnCode);
        }
        if( appId != null ){
            item.setAppId(appId);
        }
        if( mchId != null ){
            item.setMchId(mchId);
        }
        if( resultCode != null ){
            item.setResultCode(resultCode);
        }
        if( tradeType != null ){
            item.setTradeType(tradeType);
        }
        if( prepayId != null ){
            item.setPrepayId(prepayId);
        }
        if( codeUrl != null ){
            item.setCodeUrl(codeUrl);
        }
        if( prepayNo != null ){
            item.setPrepayNo(prepayNo);
        }
        if( responseXml != null ){
            item.setResponseXml(responseXml);
        }
        tPlatformWeixinPayUnifiedOrderRespService.update(item);

        return tPlatformWeixinPayUnifiedOrderRespService.get(id);
    }

    @ApiOperation(value = "查询'TPlatformWeixinPayUnifiedOrderResp'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_platform_weixin_pay_unified_order_resps/{t_platform_weixin_pay_unified_order_resp_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformWeixinPayUnifiedOrderResp(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_weixin_pay_unified_order_resp_id") Integer id,
            @RequestParam(value = "platformWeixinPayUnifiedOrderReqId", required = false) Integer platformWeixinPayUnifiedOrderReqId,
            @RequestParam(value = "returnCode", required = false) String returnCode,
            @RequestParam(value = "appId", required = false) String appId,
            @RequestParam(value = "mchId", required = false) String mchId,
            @RequestParam(value = "resultCode", required = false) String resultCode,
            @RequestParam(value = "tradeType", required = false) String tradeType,
            @RequestParam(value = "prepayId", required = false) String prepayId,
            @RequestParam(value = "codeUrl", required = false) String codeUrl,
            @RequestParam(value = "prepayNo", required = false) String prepayNo,
            @RequestParam(value = "responseXml", required = false) String responseXml
    ) {
        if(request.getMethod().equals("GET")){
            TPlatformWeixinPayUnifiedOrderResp item = tPlatformWeixinPayUnifiedOrderRespService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TPlatformWeixinPayUnifiedOrderResp item = tPlatformWeixinPayUnifiedOrderRespService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( platformWeixinPayUnifiedOrderReqId != null ){
                item.setPlatformWeixinPayUnifiedOrderReqId(platformWeixinPayUnifiedOrderReqId);
            }
            if( returnCode != null ){
                item.setReturnCode(returnCode);
            }
            if( appId != null ){
                item.setAppId(appId);
            }
            if( mchId != null ){
                item.setMchId(mchId);
            }
            if( resultCode != null ){
                item.setResultCode(resultCode);
            }
            if( tradeType != null ){
                item.setTradeType(tradeType);
            }
            if( prepayId != null ){
                item.setPrepayId(prepayId);
            }
            if( codeUrl != null ){
                item.setCodeUrl(codeUrl);
            }
            if( prepayNo != null ){
                item.setPrepayNo(prepayNo);
            }
            if( responseXml != null ){
                item.setResponseXml(responseXml);
            }
            tPlatformWeixinPayUnifiedOrderRespService.update(item);

            return tPlatformWeixinPayUnifiedOrderRespService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TPlatformWeixinPayUnifiedOrderResp item = tPlatformWeixinPayUnifiedOrderRespService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tPlatformWeixinPayUnifiedOrderRespService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TPlatformWeixinPayUnifiedOrderResp'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_platform_weixin_pay_unified_order_resps",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformWeixinPayUnifiedOrderResps(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tPlatformWeixinPayUnifiedOrderRespService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tPlatformWeixinPayUnifiedOrderRespService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_platform_weixin_pay_unified_order_resps/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformWeixinPayUnifiedOrderRespsId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TPlatformWeixinPayUnifiedOrderResp> list = tPlatformWeixinPayUnifiedOrderRespService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TPlatformWeixinPayUnifiedOrderResp.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TPlatformWeixinPayUnifiedOrderResp'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_platform_weixin_pay_unified_order_resps/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTPlatformWeixinPayUnifiedOrderResps(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TPlatformWeixinPayUnifiedOrderResp> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TPlatformWeixinPayUnifiedOrderResp item = new TPlatformWeixinPayUnifiedOrderResp();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("platformWeixinPayUnifiedOrderReqId")   ){
            item.setPlatformWeixinPayUnifiedOrderReqId(Integer.valueOf(jsonObject.get("platformWeixinPayUnifiedOrderReqId").toString()));
        }
        if(jsonObject.containsKey("returnCode")   ){
            item.setReturnCode(jsonObject.get("returnCode").toString());
        }
        if(jsonObject.containsKey("appId")   ){
            item.setAppId(jsonObject.get("appId").toString());
        }
        if(jsonObject.containsKey("mchId")   ){
            item.setMchId(jsonObject.get("mchId").toString());
        }
        if(jsonObject.containsKey("resultCode")   ){
            item.setResultCode(jsonObject.get("resultCode").toString());
        }
        if(jsonObject.containsKey("tradeType")   ){
            item.setTradeType(jsonObject.get("tradeType").toString());
        }
        if(jsonObject.containsKey("prepayId")   ){
            item.setPrepayId(jsonObject.get("prepayId").toString());
        }
        if(jsonObject.containsKey("codeUrl")   ){
            item.setCodeUrl(jsonObject.get("codeUrl").toString());
        }
        if(jsonObject.containsKey("prepayNo")   ){
            item.setPrepayNo(jsonObject.get("prepayNo").toString());
        }
        if(jsonObject.containsKey("responseXml")   ){
            item.setResponseXml(jsonObject.get("responseXml").toString());
        }
             tPlatformWeixinPayUnifiedOrderRespService.create(item);
             lists.add(tPlatformWeixinPayUnifiedOrderRespService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TPlatformWeixinPayUnifiedOrderResp'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_platform_weixin_pay_unified_order_resps/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTPlatformWeixinPayUnifiedOrderResp(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TPlatformWeixinPayUnifiedOrderResp item = tPlatformWeixinPayUnifiedOrderRespService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tPlatformWeixinPayUnifiedOrderRespService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
