package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TValueAddService;
import com.haomostudio.so.service.TValueAddServiceService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TValueAddService")
@Controller
public class TValueAddServiceController {

    @Autowired
    TValueAddServiceService tValueAddServiceService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TValueAddService'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_value_add_services/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTValueAddService(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "providerId", required = false) Integer providerId,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "name", required = false) String name,
            @RequestParam(value = "description", required = false) String description,
            @RequestParam(value = "type", required = false) Integer type,
            @RequestParam(value = "price", required = false) String price,
            @RequestParam(value = "statusCode", required = false) Integer statusCode,
            @RequestParam(value = "imgPath", required = false) String imgPath,
            @RequestParam(value = "isDelete", required = false) Integer isDelete,
            @RequestParam(value = "isOpen", required = false) Integer isOpen,
            @RequestParam(value = "createDate", required = false) String createDate,
            @RequestParam(value = "modified", required = false) String modified,
            @RequestParam(value = "tag", required = false) String tag
    ) {
        TValueAddService item = new TValueAddService();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( providerId != null ){
            item.setProviderId(providerId);
        }
        if( spaceId != null ){
            item.setSpaceId(spaceId);
        }
        if( name != null ){
            item.setName(name);
        }
        if( description != null ){
            item.setDescription(description);
        }
        if( type != null ){
            item.setType(type);
        }
        if( price != null ){
            item.setPrice(price);
        }
        if( statusCode != null ){
            item.setStatusCode(statusCode);
        }
        if( imgPath != null ){
            item.setImgPath(imgPath);
        }
        if( isDelete != null ){
            item.setIsDelete(isDelete);
        }
        if( isOpen != null ){
            item.setIsOpen(isOpen);
        }
        if( createDate != null ){
            item.setCreateDate(Tools.convertStringToDate(createDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( modified != null ){
            item.setModified(Tools.convertStringToDate(modified, "yyyy-MM-dd HH:mm:ss"));
        }
        if( tag != null ){
            item.setTag(tag);
        }
        tValueAddServiceService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tValueAddServiceService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TValueAddService'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_value_add_services/{t_value_add_service_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTValueAddService(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_value_add_service_id") Integer id
    ) {
        TValueAddService item = tValueAddServiceService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tValueAddServiceService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TValueAddService'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_value_add_services/{t_value_add_service_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTValueAddService(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_value_add_service_id") Integer id,
            @RequestParam(value = "providerId", required = false) Integer providerId,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "name", required = false) String name,
            @RequestParam(value = "description", required = false) String description,
            @RequestParam(value = "type", required = false) Integer type,
            @RequestParam(value = "price", required = false) String price,
            @RequestParam(value = "statusCode", required = false) Integer statusCode,
            @RequestParam(value = "imgPath", required = false) String imgPath,
            @RequestParam(value = "isDelete", required = false) Integer isDelete,
            @RequestParam(value = "isOpen", required = false) Integer isOpen,
            @RequestParam(value = "createDate", required = false) String createDate,
            @RequestParam(value = "modified", required = false) String modified,
            @RequestParam(value = "tag", required = false) String tag
    ) {
        TValueAddService item = tValueAddServiceService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( providerId != null ){
            item.setProviderId(providerId);
        }
        if( spaceId != null ){
            item.setSpaceId(spaceId);
        }
        if( name != null ){
            item.setName(name);
        }
        if( description != null ){
            item.setDescription(description);
        }
        if( type != null ){
            item.setType(type);
        }
        if( price != null ){
            item.setPrice(price);
        }
        if( statusCode != null ){
            item.setStatusCode(statusCode);
        }
        if( imgPath != null ){
            item.setImgPath(imgPath);
        }
        if( isDelete != null ){
            item.setIsDelete(isDelete);
        }
        if( isOpen != null ){
            item.setIsOpen(isOpen);
        }
        if( createDate != null ){
            item.setCreateDate(Tools.convertStringToDate(createDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( modified != null ){
            item.setModified(Tools.convertStringToDate(modified, "yyyy-MM-dd HH:mm:ss"));
        }
        if( tag != null ){
            item.setTag(tag);
        }
        tValueAddServiceService.update(item);

        return tValueAddServiceService.get(id);
    }

    @ApiOperation(value = "查询'TValueAddService'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_value_add_services/{t_value_add_service_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTValueAddService(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_value_add_service_id") Integer id,
            @RequestParam(value = "providerId", required = false) Integer providerId,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "name", required = false) String name,
            @RequestParam(value = "description", required = false) String description,
            @RequestParam(value = "type", required = false) Integer type,
            @RequestParam(value = "price", required = false) String price,
            @RequestParam(value = "statusCode", required = false) Integer statusCode,
            @RequestParam(value = "imgPath", required = false) String imgPath,
            @RequestParam(value = "isDelete", required = false) Integer isDelete,
            @RequestParam(value = "isOpen", required = false) Integer isOpen,
            @RequestParam(value = "createDate", required = false) String createDate,
            @RequestParam(value = "modified", required = false) String modified,
            @RequestParam(value = "tag", required = false) String tag
    ) {
        if(request.getMethod().equals("GET")){
            TValueAddService item = tValueAddServiceService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TValueAddService item = tValueAddServiceService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( providerId != null ){
                item.setProviderId(providerId);
            }
            if( spaceId != null ){
                item.setSpaceId(spaceId);
            }
            if( name != null ){
                item.setName(name);
            }
            if( description != null ){
                item.setDescription(description);
            }
            if( type != null ){
                item.setType(type);
            }
            if( price != null ){
                item.setPrice(price);
            }
            if( statusCode != null ){
                item.setStatusCode(statusCode);
            }
            if( imgPath != null ){
                item.setImgPath(imgPath);
            }
            if( isDelete != null ){
                item.setIsDelete(isDelete);
            }
            if( isOpen != null ){
                item.setIsOpen(isOpen);
            }
            if( createDate != null ){
                item.setCreateDate(Tools.convertStringToDate(createDate, "yyyy-MM-dd HH:mm:ss"));
            }
            if( modified != null ){
                item.setModified(Tools.convertStringToDate(modified, "yyyy-MM-dd HH:mm:ss"));
            }
            if( tag != null ){
                item.setTag(tag);
            }
            tValueAddServiceService.update(item);

            return tValueAddServiceService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TValueAddService item = tValueAddServiceService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tValueAddServiceService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TValueAddService'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_value_add_services",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTValueAddServices(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tValueAddServiceService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tValueAddServiceService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_value_add_services/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTValueAddServicesId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TValueAddService> list = tValueAddServiceService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TValueAddService.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TValueAddService'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_value_add_services/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTValueAddServices(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TValueAddService> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TValueAddService item = new TValueAddService();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("providerId")   ){
            item.setProviderId(Integer.valueOf(jsonObject.get("providerId").toString()));
        }
        if(jsonObject.containsKey("spaceId")   ){
            item.setSpaceId(Integer.valueOf(jsonObject.get("spaceId").toString()));
        }
        if(jsonObject.containsKey("name")   ){
            item.setName(jsonObject.get("name").toString());
        }
        if(jsonObject.containsKey("description")   ){
            item.setDescription(jsonObject.get("description").toString());
        }
        if(jsonObject.containsKey("type")   ){
            item.setType(Integer.valueOf(jsonObject.get("type").toString()));
        }
        if(jsonObject.containsKey("price")   ){
            item.setPrice(jsonObject.get("price").toString());
        }
        if(jsonObject.containsKey("statusCode")   ){
            item.setStatusCode(Integer.valueOf(jsonObject.get("statusCode").toString()));
        }
        if(jsonObject.containsKey("imgPath")   ){
            item.setImgPath(jsonObject.get("imgPath").toString());
        }
        if(jsonObject.containsKey("isDelete")   ){
            item.setIsDelete(Integer.valueOf(jsonObject.get("isDelete").toString()));
        }
        if(jsonObject.containsKey("isOpen")   ){
            item.setIsOpen(Integer.valueOf(jsonObject.get("isOpen").toString()));
        }
        if(jsonObject.containsKey("createDate")   ){
            item.setCreateDate(Tools.convertStringToDate(jsonObject.get("createDate").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("modified")   ){
            item.setModified(Tools.convertStringToDate(jsonObject.get("modified").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("tag")   ){
            item.setTag(jsonObject.get("tag").toString());
        }
             tValueAddServiceService.create(item);
             lists.add(tValueAddServiceService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TValueAddService'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_value_add_services/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTValueAddService(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TValueAddService item = tValueAddServiceService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tValueAddServiceService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
